diff --git a/src/backend/executor/nodeWindowAgg.c b/src/backend/executor/nodeWindowAgg.c
index 0b558e5..2b64175 100644
*** a/src/backend/executor/nodeWindowAgg.c
--- b/src/backend/executor/nodeWindowAgg.c
*************** typedef struct WindowStatePerFuncData
*** 102,119 ****
   */
  typedef struct WindowStatePerAggData
  {
! 	/* Oids of transfer functions */
  	Oid			transfn_oid;
  	Oid			finalfn_oid;	/* may be InvalidOid */
  
  	/*
! 	 * fmgr lookup data for transfer functions --- only valid when
  	 * corresponding oid is not InvalidOid.  Note in particular that fn_strict
  	 * flags are kept here.
  	 */
  	FmgrInfo	transfn;
  	FmgrInfo	finalfn;
  
  	/*
  	 * initial value from pg_aggregate entry
  	 */
--- 102,125 ----
   */
  typedef struct WindowStatePerAggData
  {
! 	/* Oids of transition functions */
  	Oid			transfn_oid;
+ 	Oid			invtransfn_oid; /* may be InvalidOid */
  	Oid			finalfn_oid;	/* may be InvalidOid */
  
  	/*
! 	 * fmgr lookup data for transition functions --- only valid when
  	 * corresponding oid is not InvalidOid.  Note in particular that fn_strict
  	 * flags are kept here.
  	 */
  	FmgrInfo	transfn;
+ 	FmgrInfo	invtransfn;
  	FmgrInfo	finalfn;
  
+ 	/* Aggregate properties */
+ 	bool		use_invtransfn;			/* whether to use the invtransfn */
+ 	bool		aggcontext_is_shared;	/* aggcontext is winstate's aggcontext */
+ 
  	/*
  	 * initial value from pg_aggregate entry
  	 */
*************** typedef struct WindowStatePerAggData
*** 140,149 ****
  	int			wfuncno;		/* index of associated PerFuncData */
  
  	/* Current transition value */
! 	Datum		transValue;		/* current transition value */
! 	bool		transValueIsNull;
  
! 	bool		noTransValue;	/* true if transValue not set yet */
  } WindowStatePerAggData;
  
  static void initialize_windowaggregate(WindowAggState *winstate,
--- 146,158 ----
  	int			wfuncno;		/* index of associated PerFuncData */
  
  	/* Current transition value */
! 	MemoryContext	aggcontext;			/* context for transValue */
! 	int64			transValueCount;	/* Number of aggregated values*/
! 	Datum			transValue;			/* current transition value */
! 	bool			transValueIsNull;
  
! 	/* Data local to eval_windowaggregates() */
! 	bool			restart;			/* tmp marker that agg needs restart */
  } WindowStatePerAggData;
  
  static void initialize_windowaggregate(WindowAggState *winstate,
*************** static void initialize_windowaggregate(W
*** 152,157 ****
--- 161,169 ----
  static void advance_windowaggregate(WindowAggState *winstate,
  						WindowStatePerFunc perfuncstate,
  						WindowStatePerAgg peraggstate);
+ static bool retreat_windowaggregate(WindowAggState *winstate,
+ 						WindowStatePerFunc perfuncstate,
+ 						WindowStatePerAgg peraggstate);
  static void finalize_windowaggregate(WindowAggState *winstate,
  						 WindowStatePerFunc perfuncstate,
  						 WindowStatePerAgg peraggstate,
*************** static bool are_peers(WindowAggState *wi
*** 181,186 ****
--- 193,245 ----
  static bool window_gettupleslot(WindowObject winobj, int64 pos,
  					TupleTableSlot *slot);
  
+ /*
+  * AggCheckCallContext - test if a SQL function is being called as an aggregate
+  *
+  * The transition and/or final functions of an aggregate may want to verify
+  * that they are being called as aggregates, rather than as plain SQL
+  * functions.  They should use this function to do so.	The return value
+  * is nonzero if being called as an aggregate, or zero if not.	(Specific
+  * nonzero values are AGG_CONTEXT_AGGREGATE or AGG_CONTEXT_WINDOW, but more
+  * values could conceivably appear in future.)
+  *
+  * If aggcontext isn't NULL, the function also stores at *aggcontext the
+  * identity of the memory context that aggregate transition values are
+  * being stored in.
+  *
+  * This must live here, not in nodeAgg.c, because WindowStatePerAggData
+  * is private.
+  *
+  * Note that this function is only meant to be used by aggregate support
+  * functions, NOT by true window functions.
+  */
+ int
+ AggCheckCallContext(FunctionCallInfo fcinfo, MemoryContext *aggcontext)
+ {
+ 	if (fcinfo->context && IsA(fcinfo->context, AggState))
+ 	{
+ 		if (aggcontext)
+ 			*aggcontext = ((AggState *) fcinfo->context)->aggcontext;
+ 		return AGG_CONTEXT_AGGREGATE;
+ 	}
+ 	if (fcinfo->context && IsA(fcinfo->context, WindowAggState))
+ 	{
+ 		if (aggcontext)
+ 		{
+ 			/* Must lookup per-aggregate context */
+ 			WindowAggState *winstate = (WindowAggState *) fcinfo->context;
+ 			int				aggno = winstate->calledaggno;
+ 			Assert(0 <= aggno && aggno < winstate->numaggs);
+ 			*aggcontext = winstate->peragg[aggno].aggcontext;
+ 		}
+ 		return AGG_CONTEXT_WINDOW;
+ 	}
+ 
+ 	/* this is just to prevent "uninitialized variable" warnings */
+ 	if (aggcontext)
+ 		*aggcontext = NULL;
+ 	return 0;
+ }
  
  /*
   * initialize_windowaggregate
*************** initialize_windowaggregate(WindowAggStat
*** 193,210 ****
  {
  	MemoryContext oldContext;
  
  	if (peraggstate->initValueIsNull)
! 		peraggstate->transValue = peraggstate->initValue;
  	else
  	{
! 		oldContext = MemoryContextSwitchTo(winstate->aggcontext);
  		peraggstate->transValue = datumCopy(peraggstate->initValue,
  											peraggstate->transtypeByVal,
  											peraggstate->transtypeLen);
  		MemoryContextSwitchTo(oldContext);
  	}
  	peraggstate->transValueIsNull = peraggstate->initValueIsNull;
! 	peraggstate->noTransValue = peraggstate->initValueIsNull;
  	peraggstate->resultValueIsNull = true;
  }
  
--- 252,277 ----
  {
  	MemoryContext oldContext;
  
+ 	/* If we're using a private aggcontext, we may reset it here. But if the
+ 	 * context is shared, we don't know which other aggregates may still need
+ 	 * it, so we must leave it to the caller to reset at an appropriate time
+ 	 */
+ 	if (!peraggstate->aggcontext_is_shared)
+ 		MemoryContextResetAndDeleteChildren(peraggstate->aggcontext);
+ 
  	if (peraggstate->initValueIsNull)
! 		peraggstate->transValue = (Datum) 0;
  	else
  	{
! 		oldContext = MemoryContextSwitchTo(peraggstate->aggcontext);
  		peraggstate->transValue = datumCopy(peraggstate->initValue,
  											peraggstate->transtypeByVal,
  											peraggstate->transtypeLen);
  		MemoryContextSwitchTo(oldContext);
  	}
+ 	peraggstate->transValueCount = 0;
  	peraggstate->transValueIsNull = peraggstate->initValueIsNull;
! 	peraggstate->resultValue = (Datum) 0;
  	peraggstate->resultValueIsNull = true;
  }
  
*************** advance_windowaggregate(WindowAggState *
*** 256,265 ****
  
  	if (peraggstate->transfn.fn_strict)
  	{
! 		/*
! 		 * For a strict transfn, nothing happens when there's a NULL input; we
! 		 * just keep the prior transValue.
! 		 */
  		for (i = 1; i <= numArguments; i++)
  		{
  			if (fcinfo->argnull[i])
--- 323,329 ----
  
  	if (peraggstate->transfn.fn_strict)
  	{
! 		/* Skip NULL inputs for aggregates which desire that. */
  		for (i = 1; i <= numArguments; i++)
  		{
  			if (fcinfo->argnull[i])
*************** advance_windowaggregate(WindowAggState *
*** 268,308 ****
  				return;
  			}
  		}
! 		if (peraggstate->noTransValue)
  		{
! 			/*
! 			 * transValue has not been initialized. This is the first non-NULL
! 			 * input value. We use it as the initial value for transValue. (We
! 			 * already checked that the agg's input type is binary-compatible
! 			 * with its transtype, so straight copy here is OK.)
! 			 *
! 			 * We must copy the datum into aggcontext if it is pass-by-ref. We
! 			 * do not need to pfree the old transValue, since it's NULL.
! 			 */
! 			MemoryContextSwitchTo(winstate->aggcontext);
  			peraggstate->transValue = datumCopy(fcinfo->arg[1],
  												peraggstate->transtypeByVal,
  												peraggstate->transtypeLen);
  			peraggstate->transValueIsNull = false;
! 			peraggstate->noTransValue = false;
  			MemoryContextSwitchTo(oldContext);
  			return;
  		}
  		if (peraggstate->transValueIsNull)
  		{
- 			/*
- 			 * Don't call a strict function with NULL inputs.  Note it is
- 			 * possible to get here despite the above tests, if the transfn is
- 			 * strict *and* returned a NULL on a prior cycle. If that happens
- 			 * we will propagate the NULL all the way to the end.
- 			 */
  			MemoryContextSwitchTo(oldContext);
  			return;
  		}
  	}
  
  	/*
  	 * OK to call the transition function
  	 */
  	InitFunctionCallInfoData(*fcinfo, &(peraggstate->transfn),
  							 numArguments + 1,
--- 332,388 ----
  				return;
  			}
  		}
! 
! 		/*
! 		 * For strict transfer functions with initial value NULL we use the
! 		 * first non-NULL input as the initial state. (We already checked that
! 		 * the agg's input type is binary-compatible with its transtype, so
! 		 * straight copy here is OK.)
! 		 *
! 		 * We must copy the datum into aggcontext if it is pass-by-ref. We do
! 		 * not need to pfree the old transValue, since it's NULL.
! 		 */
! 		if (peraggstate->transValueCount == 0 && peraggstate->transValueIsNull)
  		{
! 			MemoryContextSwitchTo(peraggstate->aggcontext);
  			peraggstate->transValue = datumCopy(fcinfo->arg[1],
  												peraggstate->transtypeByVal,
  												peraggstate->transtypeLen);
  			peraggstate->transValueIsNull = false;
! 			peraggstate->transValueCount = 1;
  			MemoryContextSwitchTo(oldContext);
  			return;
  		}
+ 
+ 		/*
+ 		 * Don't call a strict function with NULL inputs.  Note it is possible
+ 		 * to get here despite the above tests, if the transfn is strict *and*
+ 		 * returned a NULL on a prior cycle. If that happens we will propagate
+ 		 * the NULL all the way to the end. That can only happen if there's no
+ 		 * inverse transition function, though, since we disallow transitions
+ 		 * back to NULL if there is one below.
+ 		 */
  		if (peraggstate->transValueIsNull)
  		{
  			MemoryContextSwitchTo(oldContext);
+ 			Assert(peraggstate->invtransfn_oid == InvalidOid);
  			return;
  		}
  	}
  
  	/*
+ 	 * We must track the number of inputs that we add to transValue, since
+ 	 * to remove the last input, retreat_windowaggregate() musn't call the
+ 	 * inverse transition function, but simply reset transValue back to its
+ 	 * initial value.
+ 	 */
+ 	Assert(peraggstate->transValueCount >= 0);
+ 	peraggstate->transValueCount++;
+ 
+ 	/*
  	 * OK to call the transition function
+ 	 * Transfer functions with an inverse MUST not return NULL, see
+ 	 * retreat_windowaggregate()
  	 */
  	InitFunctionCallInfoData(*fcinfo, &(peraggstate->transfn),
  							 numArguments + 1,
*************** advance_windowaggregate(WindowAggState *
*** 310,316 ****
--- 390,404 ----
  							 (void *) winstate, NULL);
  	fcinfo->arg[0] = peraggstate->transValue;
  	fcinfo->argnull[0] = peraggstate->transValueIsNull;
+ 	winstate->calledaggno = perfuncstate->aggno;
  	newVal = FunctionCallInvoke(fcinfo);
+ 	winstate->calledaggno = -1;
+ 	if (peraggstate->invtransfn_oid != InvalidOid && fcinfo->isnull)
+ 	{
+ 		ereport(ERROR,
+ 				(errcode(ERRCODE_NULL_VALUE_NOT_ALLOWED),
+ 				 errmsg("transition function with an inverse returned NULL")));
+ 	}
  
  	/*
  	 * If pass-by-ref datatype, must copy the new value into aggcontext and
*************** advance_windowaggregate(WindowAggState *
*** 322,328 ****
  	{
  		if (!fcinfo->isnull)
  		{
! 			MemoryContextSwitchTo(winstate->aggcontext);
  			newVal = datumCopy(newVal,
  							   peraggstate->transtypeByVal,
  							   peraggstate->transtypeLen);
--- 410,416 ----
  	{
  		if (!fcinfo->isnull)
  		{
! 			MemoryContextSwitchTo(peraggstate->aggcontext);
  			newVal = datumCopy(newVal,
  							   peraggstate->transtypeByVal,
  							   peraggstate->transtypeLen);
*************** advance_windowaggregate(WindowAggState *
*** 337,342 ****
--- 425,571 ----
  }
  
  /*
+  * retreat_windowaggregate
+  * removes tuples from aggregation.
+  * The calling function must ensure that each aggregate has
+  * a valid inverse transition function.
+  */
+ static bool
+ retreat_windowaggregate(WindowAggState *winstate,
+ 						WindowStatePerFunc perfuncstate,
+ 						WindowStatePerAgg peraggstate)
+ {
+ 	WindowFuncExprState *wfuncstate = perfuncstate->wfuncstate;
+ 	int			numArguments = perfuncstate->numArguments;
+ 	FunctionCallInfoData fcinfodata;
+ 	FunctionCallInfo fcinfo = &fcinfodata;
+ 	Datum		newVal;
+ 	ListCell   *arg;
+ 	int			i;
+ 	MemoryContext oldContext;
+ 	ExprContext *econtext = winstate->tmpcontext;
+ 	ExprState  *filter = wfuncstate->aggfilter;
+ 
+ 	oldContext = MemoryContextSwitchTo(econtext->ecxt_per_tuple_memory);
+ 
+ 	/* Skip anything FILTERed out */
+ 	if (filter)
+ 	{
+ 		bool		isnull;
+ 		Datum		res = ExecEvalExpr(filter, econtext, &isnull, NULL);
+ 
+ 		if (isnull || !DatumGetBool(res))
+ 		{
+ 			MemoryContextSwitchTo(oldContext);
+ 			return true;
+ 		}
+ 	}
+ 
+ 	/* We start from 1, since the 0th arg will be the transition value */
+ 	i = 1;
+ 	foreach(arg, wfuncstate->args)
+ 	{
+ 		ExprState  *argstate = (ExprState *) lfirst(arg);
+ 
+ 		fcinfo->arg[i] = ExecEvalExpr(argstate, econtext,
+ 									  &fcinfo->argnull[i], NULL);
+ 		i++;
+ 	}
+ 
+ 	/* Skip inputs containing NULLS for aggregates that require this */
+ 	if (peraggstate->invtransfn.fn_strict)
+ 	{
+ 		for (i = 1; i <= numArguments; i++)
+ 		{
+ 			if (fcinfo->argnull[i])
+ 			{
+ 				MemoryContextSwitchTo(oldContext);
+ 				return true;
+ 			}
+ 		}
+ 	}
+ 
+ 	/* There should still be an added but not yet removed value */
+ 	Assert(peraggstate->transValueCount >= 1);
+ 
+ 	/*
+ 	 * We mustn't use the inverse transition function to remove the last
+ 	 * input. Doing so would yield a non-NULL state, whereas we should be
+ 	 * in the initial state afterwards which may very well be NULL. So
+ 	 * instead, we simply re-initialize the aggregation in this case.
+ 	 */
+ 	if (peraggstate->transValueCount == 1)
+ 	{
+ 		MemoryContextSwitchTo(oldContext);
+ 		initialize_windowaggregate(winstate,
+ 								&winstate->perfunc[peraggstate->wfuncno],
+ 								peraggstate);
+ 		return true;
+ 	}
+ 
+ 	/*
+ 	 * Perform the inverse transition.
+ 	 *
+ 	 * For pairs of forward and inverse transition functions, the state may
+ 	 * never be NULL, except in the ignore_nulls case, and then only until
+ 	 * until we see the first non-NULL input during which time should never
+ 	 * attempt to invoke the inverse transition function. Excluding NULL
+ 	 * as a possible state value allows us to make it mean "sorry, can't
+ 	 * do an inverse transition in this case" when returned by the inverse
+ 	 * transition function. In that case, we report the failure to the
+ 	 * caller.
+ 	 */
+ 	if (peraggstate->transValueIsNull)
+ 	{
+ 		MemoryContextSwitchTo(oldContext);
+ 		elog(ERROR, "transition value is NULL during inverse transition");
+ 	}
+ 	InitFunctionCallInfoData(*fcinfo, &(peraggstate->invtransfn),
+ 							 numArguments + 1,
+ 							 perfuncstate->winCollation,
+ 							 (void *) winstate, NULL);
+ 	fcinfo->arg[0] = peraggstate->transValue;
+ 	fcinfo->argnull[0] = peraggstate->transValueIsNull;
+ 	winstate->calledaggno = perfuncstate->aggno;
+ 	newVal = FunctionCallInvoke(fcinfo);
+ 	winstate->calledaggno = -1;
+ 	if (fcinfo->isnull)
+ 	{
+ 		MemoryContextSwitchTo(oldContext);
+ 		return false;
+ 	}
+ 
+ 	/* Update number of added but not yet removed values */
+ 	peraggstate->transValueCount--;
+ 
+ 	/*
+ 	 * If pass-by-ref datatype, must copy the new value into aggcontext and
+ 	 * pfree the prior transValue.	But if invtransfn returned a pointer to its
+ 	 * first input, we don't need to do anything.
+ 	 */
+ 	if (!peraggstate->transtypeByVal &&
+ 		DatumGetPointer(newVal) != DatumGetPointer(peraggstate->transValue))
+ 	{
+ 		if (!fcinfo->isnull)
+ 		{
+ 			MemoryContextSwitchTo(peraggstate->aggcontext);
+ 			newVal = datumCopy(newVal,
+ 							   peraggstate->transtypeByVal,
+ 							   peraggstate->transtypeLen);
+ 		}
+ 		if (!peraggstate->transValueIsNull)
+ 			pfree(DatumGetPointer(peraggstate->transValue));
+ 	}
+ 
+ 	MemoryContextSwitchTo(oldContext);
+ 	peraggstate->transValue = newVal;
+ 	peraggstate->transValueIsNull = fcinfo->isnull;
+ 
+ 	return true;
+ }
+ 
+ 
+ /*
   * finalize_windowaggregate
   * parallel to finalize_aggregate in nodeAgg.c
   */
*************** finalize_windowaggregate(WindowAggState 
*** 370,376 ****
--- 599,607 ----
  		}
  		else
  		{
+ 			winstate->calledaggno = perfuncstate->aggno;
  			*result = FunctionCallInvoke(&fcinfo);
+ 			winstate->calledaggno = -1;
  			*isnull = fcinfo.isnull;
  		}
  	}
*************** finalize_windowaggregate(WindowAggState 
*** 392,402 ****
  	MemoryContextSwitchTo(oldContext);
  }
  
  /*
   * eval_windowaggregates
   * evaluate plain aggregates being used as window functions
   *
!  * Much of this is duplicated from nodeAgg.c.  But NOTE that we expect to be
   * able to call aggregate final functions repeatedly after aggregating more
   * data onto the same transition value.  This is not a behavior required by
   * nodeAgg.c.
--- 623,636 ----
  	MemoryContextSwitchTo(oldContext);
  }
  
+ 
  /*
   * eval_windowaggregates
   * evaluate plain aggregates being used as window functions
   *
!  * This differes from nodeAgg.c in two ways. First, if the window's frame
!  * start position moves, we use the inverse transfer function (if it exists)
!  * to remove values from the transition value. And second, we expect to be
   * able to call aggregate final functions repeatedly after aggregating more
   * data onto the same transition value.  This is not a behavior required by
   * nodeAgg.c.
*************** eval_windowaggregates(WindowAggState *wi
*** 406,417 ****
  {
  	WindowStatePerAgg peraggstate;
  	int			wfuncno,
! 				numaggs;
! 	int			i;
  	MemoryContext oldContext;
  	ExprContext *econtext;
  	WindowObject agg_winobj;
! 	TupleTableSlot *agg_row_slot;
  
  	numaggs = winstate->numaggs;
  	if (numaggs == 0)
--- 640,654 ----
  {
  	WindowStatePerAgg peraggstate;
  	int			wfuncno,
! 				numaggs,
! 				numaggs_restart = 0,
! 				i;
! 	int64		aggregatedupto_nonrestarted;
  	MemoryContext oldContext;
  	ExprContext *econtext;
  	WindowObject agg_winobj;
! 	TupleTableSlot *agg_row_slot = winstate->agg_row_slot;
! 	TupleTableSlot *temp_slot = winstate->temp_slot_1;
  
  	numaggs = winstate->numaggs;
  	if (numaggs == 0)
*************** eval_windowaggregates(WindowAggState *wi
*** 420,426 ****
  	/* final output execution is in ps_ExprContext */
  	econtext = winstate->ss.ps.ps_ExprContext;
  	agg_winobj = winstate->agg_winobj;
- 	agg_row_slot = winstate->agg_row_slot;
  
  	/*
  	 * Currently, we support only a subset of the SQL-standard window framing
--- 657,662 ----
*************** eval_windowaggregates(WindowAggState *wi
*** 438,446 ****
  	 * damage the running transition value, but we have the same assumption in
  	 * nodeAgg.c too (when it rescans an existing hash table).
  	 *
! 	 * For other frame start rules, we discard the aggregate state and re-run
! 	 * the aggregates whenever the frame head row moves.  We can still
! 	 * optimize as above whenever successive rows share the same frame head.
  	 *
  	 * In many common cases, multiple rows share the same frame and hence the
  	 * same aggregate value. (In particular, if there's no ORDER BY in a RANGE
--- 674,693 ----
  	 * damage the running transition value, but we have the same assumption in
  	 * nodeAgg.c too (when it rescans an existing hash table).
  	 *
! 	 * We can still optimize as above whenever successive rows share the same
! 	 * frame head, but if the frame head moves beyond the aggregated base point
! 	 * we use the aggregate function's inverse transition function. This
! 	 * removes the tuple from aggregation and restores the aggregate's current
! 	 * state to what it would be if the removed row had never been aggregated
! 	 * in the first place. Inverse transition functions may optionally return
! 	 * NULL, this indicates that the function was unable to remove the tuple
! 	 * from aggregation, when this happens we must perform the aggregation all
! 	 * over again for all tuples in the new frame boundary.
! 	 *
! 	 * If the aggregate function does not have a inverse transition function
! 	 * and the frame head moves beyond the aggregated position then we must
! 	 * discard the aggregated state and re-aggregate similar to how we would
! 	 * have to if the inverse transition function had returned NULL.
  	 *
  	 * In many common cases, multiple rows share the same frame and hence the
  	 * same aggregate value. (In particular, if there's no ORDER BY in a RANGE
*************** eval_windowaggregates(WindowAggState *wi
*** 452,526 ****
  	 * 'aggregatedupto' keeps track of the first row that has not yet been
  	 * accumulated into the aggregate transition values.  Whenever we start a
  	 * new peer group, we accumulate forward to the end of the peer group.
- 	 *
- 	 * TODO: Rerunning aggregates from the frame start can be pretty slow. For
- 	 * some aggregates like SUM and COUNT we could avoid that by implementing
- 	 * a "negative transition function" that would be called for each row as
- 	 * it exits the frame.	We'd have to think about avoiding recalculation of
- 	 * volatile arguments of aggregate functions, too.
  	 */
  
  	/*
  	 * First, update the frame head position.
  	 */
! 	update_frameheadpos(agg_winobj, winstate->temp_slot_1);
  
  	/*
! 	 * Initialize aggregates on first call for partition, or if the frame head
! 	 * position moved since last time.
  	 */
! 	if (winstate->currentpos == 0 ||
! 		winstate->frameheadpos != winstate->aggregatedbase)
  	{
- 		/*
- 		 * Discard transient aggregate values
- 		 */
- 		MemoryContextResetAndDeleteChildren(winstate->aggcontext);
- 
  		for (i = 0; i < numaggs; i++)
  		{
  			peraggstate = &winstate->peragg[i];
  			wfuncno = peraggstate->wfuncno;
! 			initialize_windowaggregate(winstate,
! 									   &winstate->perfunc[wfuncno],
! 									   peraggstate);
  		}
  
  		/*
! 		 * If we created a mark pointer for aggregates, keep it pushed up to
! 		 * frame head, so that tuplestore can discard unnecessary rows.
  		 */
! 		if (agg_winobj->markptr >= 0)
! 			WinSetMarkPosition(agg_winobj, winstate->frameheadpos);
  
  		/*
! 		 * Initialize for loop below
  		 */
! 		ExecClearTuple(agg_row_slot);
! 		winstate->aggregatedbase = winstate->frameheadpos;
! 		winstate->aggregatedupto = winstate->frameheadpos;
  	}
  
  	/*
! 	 * In UNBOUNDED_FOLLOWING mode, we don't have to recalculate aggregates
! 	 * except when the frame head moves.  In END_CURRENT_ROW mode, we only
! 	 * have to recalculate when the frame head moves or currentpos has
! 	 * advanced past the place we'd aggregated up to.  Check for these cases
! 	 * and if so, reuse the saved result values.
  	 */
! 	if ((winstate->frameOptions & (FRAMEOPTION_END_UNBOUNDED_FOLLOWING |
! 								   FRAMEOPTION_END_CURRENT_ROW)) &&
! 		winstate->aggregatedbase <= winstate->currentpos &&
! 		winstate->aggregatedupto > winstate->currentpos)
  	{
! 		for (i = 0; i < numaggs; i++)
  		{
- 			peraggstate = &winstate->peragg[i];
  			wfuncno = peraggstate->wfuncno;
! 			econtext->ecxt_aggvalues[wfuncno] = peraggstate->resultValue;
! 			econtext->ecxt_aggnulls[wfuncno] = peraggstate->resultValueIsNull;
  		}
! 		return;
  	}
  
  	/*
--- 699,885 ----
  	 * 'aggregatedupto' keeps track of the first row that has not yet been
  	 * accumulated into the aggregate transition values.  Whenever we start a
  	 * new peer group, we accumulate forward to the end of the peer group.
  	 */
  
  	/*
  	 * First, update the frame head position.
+ 	 *
+ 	 * The frame head should never move backwards, and the code below wouldn't
+ 	 * cope if it did, so for safety we complain if it does.
  	 */
! 	update_frameheadpos(agg_winobj, temp_slot);
! 	if (winstate->frameheadpos < winstate->aggregatedbase)
! 		elog(ERROR, "frame moved backwards unexpectedly");
  
  	/*
! 	 * If the frame didn't change compared to the previous row, we can re-use
! 	 * the cached result. Since we don't know the current frame's end yet, we
! 	 * cannot check that the obvious way. But we can exploit that if the frame
! 	 * end is UNBOUNDED FOLLOWING or CURRENT ROW, then whenever the current
! 	 * row lies within the previous row's frame, the two frame's ends must
! 	 * coincide. Note that for the first row, aggregatedbase = aggregatedupto,
! 	 * so we don't need to check for that explicitly here.
  	 */
! 	if (winstate->aggregatedbase == winstate->frameheadpos &&
! 		(winstate->frameOptions & (FRAMEOPTION_END_UNBOUNDED_FOLLOWING |
! 								   FRAMEOPTION_END_CURRENT_ROW)) &&
! 		winstate->aggregatedbase <= winstate->currentpos &&
! 		winstate->aggregatedupto > winstate->currentpos)
  	{
  		for (i = 0; i < numaggs; i++)
  		{
  			peraggstate = &winstate->peragg[i];
  			wfuncno = peraggstate->wfuncno;
! 			econtext->ecxt_aggvalues[wfuncno] = peraggstate->resultValue;
! 			econtext->ecxt_aggnulls[wfuncno] = peraggstate->resultValueIsNull;
  		}
+ 		return;
+ 	}
  
+ 	/* Initialize restart flags.
+ 	 *
+ 	 * We restart the aggregation
+ 	 *   - if we're processing the first row in the partition, or
+ 	 *   - if we the frame's head moved and we cannot use an inverse
+ 	 *     transition function, or
+ 	 *   - if the new frame doesn't overlap the old one
+ 	 *
+ 	 * Note that we don't strictly need to restart in the last case, but
+ 	 * if we're going to remove *all* rows from the aggregation anyway, a
+ 	 * restart surely is faster.
+ 	 */
+ 	for (i = 0; i < numaggs; i++)
+ 	{
+ 		peraggstate = &winstate->peragg[i];
+ 		if (winstate->currentpos == 0 ||
+ 			(winstate->aggregatedbase < winstate->frameheadpos &&
+ 			!peraggstate->use_invtransfn) ||
+ 			winstate->aggregatedupto <= winstate->frameheadpos)
+ 		{
+ 			peraggstate->restart = true;
+ 			numaggs_restart++;
+ 		}
+ 		else
+ 			peraggstate->restart = false;
+ 	}
+ 
+ 	/*
+ 	 * Attempt to update aggregatedbase to match the frame's head by
+ 	 * removing those inputs from the aggregations which fell off the top
+ 	 * of the frame. This can fail, i.e. retreat_windowaggregate() can
+ 	 * return false, in which case we restart that aggregate below.
+ 	 *
+ 	 * Aftwards, aggregatedbase equals frameheadpos.
+ 	 */
+ 	while(winstate->aggregatedbase < winstate->frameheadpos)
+ 	{
  		/*
! 		 * Fetch the tuple where the current aggregation started from.
! 		 * This should never fail as we should have been here before.
  		 */
! 		if (!window_gettupleslot(agg_winobj, winstate->aggregatedbase,
! 								 temp_slot))
! 			elog(ERROR, "Unable to find tuple in tuplestore");
! 
! 		/* Set tuple context for evaluation of aggregate arguments */
! 		winstate->tmpcontext->ecxt_outertuple = temp_slot;
  
  		/*
! 		 * Perform the inverse transition for each aggregate function in
! 		 * the window, unless it has already been marked as needing a
! 		 * restart.
  		 */
! 		for (i = 0; i < numaggs; i++)
! 		{
! 			bool	ok;
! 
! 			peraggstate = &winstate->peragg[i];
! 			if (peraggstate->restart)
! 				continue;
! 
! 			wfuncno = peraggstate->wfuncno;
! 			ok = retreat_windowaggregate(winstate,
! 										 &winstate->perfunc[wfuncno],
! 										 peraggstate);
! 			if (!ok)
! 			{
! 				/* Inverse transition function has failed, must restart */
! 				peraggstate->restart = true;
! 				numaggs_restart++;
! 			}
! 		}
! 
! 		/* Reset per-input-tuple context after each tuple */
! 		ResetExprContext(winstate->tmpcontext);
! 
! 		/* And advance the aggregated-row state */
! 		winstate->aggregatedbase++;
! 		ExecClearTuple(temp_slot);
! 
! 		/* If no more retreatable aggregates are left, we stop early */
! 		if (numaggs_restart == numaggs)
! 		{
! 			winstate->aggregatedbase = winstate->frameheadpos;
! 			break;
! 		}
  	}
  
  	/*
! 	 * If we created a mark pointer for aggregates, keep it pushed up to
! 	 * frame head, so that tuplestore can discard unnecessary rows.
  	 */
! 	if (agg_winobj->markptr >= 0)
! 		WinSetMarkPosition(agg_winobj, winstate->frameheadpos);
! 
! 	/*
! 	 * Then restart the aggregates which require it.
! 	 *
! 	 * We assume that aggregates using the shared context always restart
! 	 * if *any* aggregate restarts, and we may thus cleanup the shared
! 	 * aggcontext if that is the case. The private aggcontexts are reset
! 	 * by initialize_windowaggregate() if their owning aggregate restarts,
! 	 * otherwise we just pfree() the cached result.
! 	 */
! 	if (numaggs_restart > 0)
! 		MemoryContextResetAndDeleteChildren(winstate->aggcontext_shared);
! 	for (i = 0; i < numaggs; i++)
  	{
! 		peraggstate = &winstate->peragg[i];
! 		/* Aggregates using the shared ctx must restart if *any* agg does */
! 		Assert(!peraggstate->aggcontext_is_shared ||
! 			   !numaggs_restart || peraggstate->restart);
! 		if (!peraggstate->restart && !peraggstate->resultValueIsNull &&
! 			!peraggstate->resulttypeByVal)
! 		{
! 			pfree(DatumGetPointer(peraggstate->resultValue));
! 			peraggstate->resultValue = (Datum) 0;
! 			peraggstate->resultValueIsNull = true;
! 		}
! 		else if (peraggstate->restart)
  		{
  			wfuncno = peraggstate->wfuncno;
! 			initialize_windowaggregate(winstate,
! 									   &winstate->perfunc[wfuncno],
! 									   peraggstate);
  		}
! 	}
! 
! 	/*
! 	 * Non-restarted aggregates now contain the rows between aggregatedbase
! 	 * (i.e. frameheadpos) and aggregatedupto, and restarted aggregates
! 	 * contain no rows. If there are any restarted aggregates, we must thus
! 	 * begin aggregating anew at frameheadpos, otherwise we may simply
! 	 * continue at aggregatedupto. Since we possibly reset aggregatedupto, we
! 	 * must remember the old value to know how long to skip non-restarted
! 	 * aggregates. If we modify aggregatedupto, we must also clear
! 	 * agg_row_slot, per the loop invariant below.
! 	 */
! 	aggregatedupto_nonrestarted = winstate->aggregatedupto;
! 	if (numaggs_restart > 0 &&
! 		winstate->aggregatedupto != winstate->frameheadpos)
! 	{
! 		winstate->aggregatedupto = winstate->frameheadpos;
! 		ExecClearTuple(agg_row_slot);
  	}
  
  	/*
*************** eval_windowaggregates(WindowAggState *wi
*** 551,556 ****
--- 910,920 ----
  		for (i = 0; i < numaggs; i++)
  		{
  			peraggstate = &winstate->peragg[i];
+ 			/* Non-restarted aggs skip until aggregatedupto_nonrestarted */
+ 			if (winstate->aggregatedupto < aggregatedupto_nonrestarted &&
+ 				!peraggstate->restart)
+ 				continue;
+ 
  			wfuncno = peraggstate->wfuncno;
  			advance_windowaggregate(winstate,
  									&winstate->perfunc[wfuncno],
*************** eval_windowaggregates(WindowAggState *wi
*** 565,570 ****
--- 929,945 ----
  		ExecClearTuple(agg_row_slot);
  	}
  
+ 	/* The frame's end is not supposed to move backwards, ever */
+ 	Assert(aggregatedupto_nonrestarted <= winstate->aggregatedupto);
+ 
+ 	/* Update statistics */
+ 	if (numaggs_restart > 0)
+ 		winstate->aggfwdtrans += (winstate->aggregatedupto
+ 								  - winstate->frameheadpos);
+ 	else
+ 		winstate->aggfwdtrans += (winstate->aggregatedupto
+ 								  - aggregatedupto_nonrestarted);
+ 
  	/*
  	 * finalize aggregates and fill result/isnull fields.
  	 */
